/* Katoob
 * Copyright (c) 2002,2003 Arabeyes, Mohammed Sameer.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __ENCODINGSLIST_H__
#define __ENCODINGSLIST_H__

/******************************************************************************
 * I had to modify the languages struct names cause the original names caused *
 * the strings to be disconnected when rendered if GDK_USE_XFT != 0           *
 *****************************************************************************/

typedef struct _Lang Lang;
struct _Lang
{
  gchar *name;
  gchar *encoding;
  Lang *children;
};

Lang __arabic[] = {
  {"ISO 8859-6 (Arabic)", "ISO_8859-6", NULL},
  {"WINDOWS-1256 (Arabic)", "WINDOWS-1256", NULL},
  {NULL}
};

Lang __baltic[] = {
  {"ISO_8859-4 (Baltic)", "ISO_8859-4", NULL},
  {"ISO_8859-13 (Baltic)", "ISO_8859-13", NULL},
  {"WINDOWS-1257 (Baltic)", "WINDOWS-1257", NULL},
  {NULL}
};

Lang __central_european[] = {
  {"ISO 8859-2 (Central European)", "ISO_8859-2", NULL},
  {"WINDOWS-1250 (Central European)", "WINDOWS-1250", NULL},
  {NULL}
};

Lang __cyrillic[] = {
  {"ISO_8859-5 (Cyrillic)", "ISO_8859-5", NULL},
  {"WINDOWS-1251 (Cyrillic)", "WINDOWS-1251", NULL},
  {NULL}
};

Lang __greek[] = {
  {"ISO 8859-7 (Greek)", "ISO_8859-7", NULL},
  {"WINDOWS-1253 (Greek)", "WINDOWS-1253", NULL},
  {NULL}
};

Lang __hebrew[] = {
  {"ISO 8859-8 (Hebrew)", "ISO_8859-8", NULL},
  {"WINDOWS-1255 (Hebrew)", "WINDOWS-1255", NULL},
  {NULL}
};

Lang __romanian[] = {
  {"ISO_8859-16 (Romanian)", "ISO-8859-16", NULL},
  {NULL}
};

Lang __turkish[] = {
  {"ISO 8859-9 (Turkish)", "ISO_8859-9", NULL},
  {"WINDOWS-1254 (Turkish)", "WINDOWS-1254", NULL},
  {NULL}
};

Lang __western[] = {
  {"ISO 8859-1 (Western European)", "ISO_8859-1", NULL},
  {"ISO_8859-15 (Western, New)", "ISO_8859-15", NULL},
  {"WINDOWS-1252 (Western)", "WINDOWS-1252", NULL},
  {NULL}
};

Lang __other[] = {
  {"ISO_8859-3 (South European)", "ISO_8859-3", NULL},
  {"ISO_8859-10 (Nordic)", "ISO_8859-10", NULL},
  {"ISO_8859-11", "ISO_8859-11", NULL},
  {"ISO_8859-12", "ISO_8859-12", NULL},
  {"ISO_8859-14", "ISO_8859-14", NULL},
  {"WINDOWS-1258 (Vietnamese)", "WINDOWS-1258", NULL},
  {"PLAIN TEXT (No Unicode Control Characters)", "PLAIN TEXT", NULL},
  {"UTF-8", "UTF-8", NULL},
  {NULL}
};

Lang languages[] = {
  {"Arabic", NULL, __arabic},
  {"Baltic", NULL, __baltic},
  {"Central European", NULL, __central_european},
  {"Cyrillic", NULL, __cyrillic},
  {"Greek", NULL, __greek},
  {"Hebrew", NULL, __hebrew},
  {"Romanian", NULL, __romanian},
  {"Turkish", NULL, __turkish},
  {"Western", NULL, __western},
  {"Other", NULL, __other},
  {NULL}
};

gchar *encodings[ENCODINGS];

gchar *encodings_names[ENCODINGS];

#endif /* __ENCODINGSLIST_H__ */
